/*****************************************************\
*ϹҵѧFreescale MCU&DSPʵ
*  sdhal.c
*C  P  U STM32VBT6
*ԻIAR4.22 
*    ߣ 
*    : SD
*    ڣ2008912
\*****************************************************/

#include "stm32f10x_lib.h"
#include "sdhal.h"

/* Select MSD Card: ChipSelect pin low  */
#define MSD_CS_LOW()     GPIO_ResetBits(GPIOA, GPIO_Pin_9)
/* Deselect MSD Card: ChipSelect pin high */
#define MSD_CS_HIGH()    GPIO_SetBits(GPIOA, GPIO_Pin_9)

/* Private function prototypes -----------------------------------------------*/
static void SPI_Config(void);
/**************************************************************
		
дSDSPIӿں: SPIӿ,/ֽں	
	
**************************************************************/


/*******************************************************************************************************************
** : void SD_HardWareInit()	Name:	  void SD_HardWareInit()
** : ʼSDӲ	Function: initialize the hardware condiction that access sd card
** 䡡  : 				Input:	  NULL
**   : 				Output:	  NULL
********************************************************************************************************************/
void SD_HardWareInit(void)
{ 
	SPI_Config();			/* ,ʼ,SPIӿںSDƬѡ       	*/	
    
	MSD_CS_HIGH();

	//SPI_Clk400k();			/* BSPIΪ400k       			*/	
}

/*******************************************************************************************************************
** : void SPI_Clk400k()		Name:	  void SPI_Clk400k()
** : SPIʱС400kHZ	Function: set the clock of SPI less than 400kHZ
** 䡡  : 				Input:	  NULL
**   : 				Output:	  NULL
********************************************************************************************************************/
void SPI_Clk400k(void)
{
	SPI_InitTypeDef   SPI_InitStructure;

  	/* SPI1 Config */
  	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128;
  	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  	SPI_InitStructure.SPI_CRCPolynomial = 7;
  	SPI_Init(SPI1, &SPI_InitStructure);

  	/* SPI1 enable */
  	SPI_Cmd(SPI1, ENABLE);
}


/*******************************************************************************************************************
** : void SPI_ClkToMax()		Name:	  void SPI_ClkToMax()
** : SPIclockֵ		Function: set the clock of SPI to maximum
** 䡡  : 					Input:	  NULL
**   : 					Output:	  NULL
********************************************************************************************************************/
void SPI_ClkToMax(void)
{
	SPI_InitTypeDef   SPI_InitStructure;

  	/* SPI1 Config */
  	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  	SPI_InitStructure.SPI_CRCPolynomial = 7;
  	SPI_Init(SPI1, &SPI_InitStructure);

  	/* SPI1 enable */
  	SPI_Cmd(SPI1, ENABLE);
}


/*******************************************************************************************************************
** : void SPI_SendByte()	Name:	  void SPI_SendByte()
** : ͨSPIӿڷһֽ	Function: send a byte by SPI interface
** 䡡  : INT8U byte: ͵ֽ	Input:	  INT8U byte: the byte that will be send
**   : 				Output:	  NULL
********************************************************************************************************************/
void SPI_SendByte(INT8U byte)
{
/* Wait until the transmit buffer is empty */
  while (SPI_GetFlagStatus(SPI1, SPI_FLAG_TXE) == RESET);
  /* Send the byte */
  SPI_SendData(SPI1, byte);
}


/*******************************************************************************************************************
** : INT8U SPI_RecByte()	Name:	  INT8U SPI_RecByte()
** : SPIӿڽһֽ	Function: receive a byte from SPI interface
** 䡡  : 				Input:	  NULL
**   : յֽ			Output:	  the byte that be received
********************************************************************************************************************/
INT8U SPI_RecByte(void)
{
  INT8U Data = 0;

  /* Wait until the transmit buffer is empty */
  while (SPI_GetFlagStatus(SPI1, SPI_FLAG_TXE) == RESET);
  /* Send the byte */
  SPI_SendData(SPI1, 0xFF);

  /* Wait until a data is received */
  while (SPI_GetFlagStatus(SPI1, SPI_FLAG_RXNE) == RESET);
  /* Get the received data */
  Data = SPI_ReceiveData(SPI1);

  /* Return the shifted data */
  return Data;
}


/*******************************************************************************************************************
** : void SPI_CS_Assert()	Name:	  void SPI_CS_Assert()
** : ƬѡSPIӻ		Function: select the SPI slave 
** 䡡  : 				Input:	  NULL
**   : 				Output:	  NULL
********************************************************************************************************************/
void SPI_CS_Assert(void)
{
	MSD_CS_LOW();		/* ƬѡSPIӻ  select the SPI slave */  
}


/*******************************************************************************************************************
** : void SPI_CS_Deassert()	Name:	  void SPI_CS_Deassert()
** : ƬѡSPIӻ		Function: not select the SPI slave 
** 䡡  : 				Input:	  NULL
**   : 				Output:	  NULL
********************************************************************************************************************/
void SPI_CS_Deassert(void)
{
	MSD_CS_HIGH();		/* ƬѡSPIӻ  not select the SPI slave */
}

/*******************************************************************************************************************
** : void SD_ChkCard()		Name:	  void SD_ChkCard()
** : ⿨Ƿȫ		Function: check weather card is insert entirely
** 䡡  : 				Input:	  NULL
**   : 1: ȫ	         Output:  1: insert entirely
              0: ûȫ  	          0: not insert entirely
********************************************************************************************************************/
INT8U SD_ChkCard(void)
{
	if (SD_INSERT_STATUS() != 0)
		return 0;								/* δȫ not insert entirely */
	else
		return 1;								/* ȫ insert entirely */
}

/*******************************************************************************************************************
** : void SD_ChkCardWP()	Name:	  void SD_ChkCardWP()
** : ⿨д		Function: check weather card is write protect
** 䡡  : 				Input:	  NULL
**   : 1: д	        Output:	  1: insert write protect
             0: δд	    	          0: not write protect
********************************************************************************************************************/
INT8U SD_ChkCardWP(void)
{
	if (SD_WP_STATUS() != 0)
		return 1;								/* д */
	else
		return 0;								/* δд */
}

/*******************************************************************************
* Function Name  : SPI_Config
* Description    : Initializes the SPI1 and CS pins.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI_Config(void)
{
   GPIO_InitTypeDef  GPIO_InitStructure;
  SPI_InitTypeDef   SPI_InitStructure;

  /* GPIOA and GPIOC Periph clock enable */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOC |RCC_APB2Periph_GPIOE, ENABLE);
  /* SPI1 Periph clock enable */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);

  /* Configure SPI1 pins: SCK, MISO and MOSI */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  /* Configure  as Output push-pull, used as SD CS&PWR*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOD, &GPIO_InitStructure);

  GPIO_SetBits(GPIOA, GPIO_Pin_10);

  /* SPI1 Config */
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI1, &SPI_InitStructure);

  /* SPI1 enable */
  SPI_Cmd(SPI1, ENABLE);
}








